#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdm.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmgenerateregisterall_ DMGENERATEREGISTERALL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmgenerateregisterall_ dmgenerateregisterall
#endif
PETSC_EXTERN void dmgenerateregisterall_(PetscErrorCode *ierr)
{
  *ierr = DMGenerateRegisterAll();
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdm.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmgenerateregisterdestroy_ DMGENERATEREGISTERDESTROY
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmgenerateregisterdestroy_ dmgenerateregisterdestroy
#endif
PETSC_EXTERN void dmgenerateregisterdestroy_(PetscErrorCode *ierr)
{
  *ierr = DMGenerateRegisterDestroy();
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdm.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmadaptlabel_ DMADAPTLABEL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmadaptlabel_ dmadaptlabel
#endif
PETSC_EXTERN void dmadaptlabel_(DM *a, DMLabel *b, DM *c, PetscErrorCode *ierr)
{
  PetscBool null_c = !*(void**) c ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(c);
  *ierr = DMAdaptLabel(*a, *b, c);
  if (*ierr) return;
  if (! null_c && !*(void**) c) *(void **) c = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscdm.h>
#include <petscdm.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define dmadaptmetric_ DMADAPTMETRIC
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define dmadaptmetric_ dmadaptmetric
#endif
PETSC_EXTERN void dmadaptmetric_(DM *a, Vec *b, DMLabel *c, DMLabel *d, DM *e, PetscErrorCode *ierr)
{
  PetscBool null_e = !*(void**) e ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(e);
  *ierr = DMAdaptMetric(*a, *b, *c, *d, e);
  if (*ierr) return;
  if (! null_e && !*(void**) e) *(void **) e = (void *)-2;
}
