#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspcgsettype_ KSPCGSETTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspcgsettype_ kspcgsettype
#endif
PETSC_EXTERN void kspcgsettype_(KSP *a, KSPCGType *b, PetscErrorCode *ierr)
{
  *ierr = KSPCGSetType(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspcgusesinglereduction_ KSPCGUSESINGLEREDUCTION
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspcgusesinglereduction_ kspcgusesinglereduction
#endif
PETSC_EXTERN void kspcgusesinglereduction_(KSP *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = KSPCGUseSingleReduction(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspcgsetradius_ KSPCGSETRADIUS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspcgsetradius_ kspcgsetradius
#endif
PETSC_EXTERN void kspcgsetradius_(KSP *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = KSPCGSetRadius(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspcgsetobjectivetarget_ KSPCGSETOBJECTIVETARGET
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspcgsetobjectivetarget_ kspcgsetobjectivetarget
#endif
PETSC_EXTERN void kspcgsetobjectivetarget_(KSP *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = KSPCGSetObjectiveTarget(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspcggetnormd_ KSPCGGETNORMD
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspcggetnormd_ kspcggetnormd
#endif
PETSC_EXTERN void kspcggetnormd_(KSP *a, PetscReal *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLREAL(b);
  *ierr = KSPCGGetNormD(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspcggetobjfcn_ KSPCGGETOBJFCN
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspcggetobjfcn_ kspcggetobjfcn
#endif
PETSC_EXTERN void kspcggetobjfcn_(KSP *a, PetscReal *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLREAL(b);
  *ierr = KSPCGGetObjFcn(*a, b);
  if (*ierr) return;
}
