#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksplsqrsetcomputestandarderrorvec_ KSPLSQRSETCOMPUTESTANDARDERRORVEC
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksplsqrsetcomputestandarderrorvec_ ksplsqrsetcomputestandarderrorvec
#endif
PETSC_EXTERN void ksplsqrsetcomputestandarderrorvec_(KSP *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = KSPLSQRSetComputeStandardErrorVec(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksplsqrsetexactmatnorm_ KSPLSQRSETEXACTMATNORM
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksplsqrsetexactmatnorm_ ksplsqrsetexactmatnorm
#endif
PETSC_EXTERN void ksplsqrsetexactmatnorm_(KSP *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = KSPLSQRSetExactMatNorm(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksplsqrgetstandarderrorvec_ KSPLSQRGETSTANDARDERRORVEC
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksplsqrgetstandarderrorvec_ ksplsqrgetstandarderrorvec
#endif
PETSC_EXTERN void ksplsqrgetstandarderrorvec_(KSP *a, Vec *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = KSPLSQRGetStandardErrorVec(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksplsqrgetnorms_ KSPLSQRGETNORMS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksplsqrgetnorms_ ksplsqrgetnorms
#endif
PETSC_EXTERN void ksplsqrgetnorms_(KSP *a, PetscReal *b, PetscReal *c, PetscErrorCode *ierr)
{
  CHKFORTRANNULLREAL(b);
  CHKFORTRANNULLREAL(c);
  *ierr = KSPLSQRGetNorms(*a, b, c);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksplsqrmonitorresidual_ KSPLSQRMONITORRESIDUAL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksplsqrmonitorresidual_ ksplsqrmonitorresidual
#endif
PETSC_EXTERN void ksplsqrmonitorresidual_(KSP *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = KSPLSQRMonitorResidual(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksplsqrmonitorresidualdrawlg_ KSPLSQRMONITORRESIDUALDRAWLG
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksplsqrmonitorresidualdrawlg_ ksplsqrmonitorresidualdrawlg
#endif
PETSC_EXTERN void ksplsqrmonitorresidualdrawlg_(KSP *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = KSPLSQRMonitorResidualDrawLG(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define ksplsqrconvergeddefault_ KSPLSQRCONVERGEDDEFAULT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define ksplsqrconvergeddefault_ ksplsqrconvergeddefault
#endif
PETSC_EXTERN void ksplsqrconvergeddefault_(KSP *a, PetscInt *b, PetscReal *c, KSPConvergedReason *d, void *e, PetscErrorCode *ierr)
{
  *ierr = KSPLSQRConvergedDefault(*a, *b, *c, d, e);
  if (*ierr) return;
}
