#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspchebyshevseteigenvalues_ KSPCHEBYSHEVSETEIGENVALUES
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspchebyshevseteigenvalues_ kspchebyshevseteigenvalues
#endif
PETSC_EXTERN void kspchebyshevseteigenvalues_(KSP *a, PetscReal *b, PetscReal *c, PetscErrorCode *ierr)
{
  *ierr = KSPChebyshevSetEigenvalues(*a, *b, *c);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspchebyshevesteigset_ KSPCHEBYSHEVESTEIGSET
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspchebyshevesteigset_ kspchebyshevesteigset
#endif
PETSC_EXTERN void kspchebyshevesteigset_(KSP *a, PetscReal *b, PetscReal *c, PetscReal *d, PetscReal *e, PetscErrorCode *ierr)
{
  *ierr = KSPChebyshevEstEigSet(*a, *b, *c, *d, *e);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspchebyshevesteigsetusenoisy_ KSPCHEBYSHEVESTEIGSETUSENOISY
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspchebyshevesteigsetusenoisy_ kspchebyshevesteigsetusenoisy
#endif
PETSC_EXTERN void kspchebyshevesteigsetusenoisy_(KSP *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = KSPChebyshevEstEigSetUseNoisy(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspchebyshevesteiggetksp_ KSPCHEBYSHEVESTEIGGETKSP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspchebyshevesteiggetksp_ kspchebyshevesteiggetksp
#endif
PETSC_EXTERN void kspchebyshevesteiggetksp_(KSP *a, KSP *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = KSPChebyshevEstEigGetKSP(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspchebyshevsetkind_ KSPCHEBYSHEVSETKIND
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspchebyshevsetkind_ kspchebyshevsetkind
#endif
PETSC_EXTERN void kspchebyshevsetkind_(KSP *a, KSPChebyshevKind *b, PetscErrorCode *ierr)
{
  *ierr = KSPChebyshevSetKind(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspchebyshevgetkind_ KSPCHEBYSHEVGETKIND
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspchebyshevgetkind_ kspchebyshevgetkind
#endif
PETSC_EXTERN void kspchebyshevgetkind_(KSP *a, KSPChebyshevKind *b, PetscErrorCode *ierr)
{
  *ierr = KSPChebyshevGetKind(*a, b);
  if (*ierr) return;
}
