#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define matlmvmsymbroydensetdelta_ MATLMVMSYMBROYDENSETDELTA
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define matlmvmsymbroydensetdelta_ matlmvmsymbroydensetdelta
#endif
PETSC_EXTERN void matlmvmsymbroydensetdelta_(Mat *a, PetscScalar *b, PetscErrorCode *ierr)
{
  *ierr = MatLMVMSymBroydenSetDelta(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define matlmvmsymbroydensetscaletype_ MATLMVMSYMBROYDENSETSCALETYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define matlmvmsymbroydensetscaletype_ matlmvmsymbroydensetscaletype
#endif
PETSC_EXTERN void matlmvmsymbroydensetscaletype_(Mat *a, MatLMVMSymBroydenScaleType *b, PetscErrorCode *ierr)
{
  *ierr = MatLMVMSymBroydenSetScaleType(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define matcreatelmvmsymbroyden_ MATCREATELMVMSYMBROYDEN
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define matcreatelmvmsymbroyden_ matcreatelmvmsymbroyden
#endif
PETSC_EXTERN void matcreatelmvmsymbroyden_(MPI_Fint *a, PetscInt *b, PetscInt *c, Mat *d, PetscErrorCode *ierr)
{
  PetscBool null_d = !*(void**) d ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(d);
  *ierr = MatCreateLMVMSymBroyden(MPI_Comm_f2c(*(a)), *b, *c, d);
  if (*ierr) return;
  if (! null_d && !*(void**) d) *(void **) d = (void *)-2;
}
