#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommsetfromoptions_ PETSCSUBCOMMSETFROMOPTIONS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommsetfromoptions_ petscsubcommsetfromoptions
#endif
PETSC_EXTERN void petscsubcommsetfromoptions_(PetscSubcomm *a, PetscErrorCode *ierr)
{
  *ierr = PetscSubcommSetFromOptions(*a);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommsetoptionsprefix_ PETSCSUBCOMMSETOPTIONSPREFIX
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommsetoptionsprefix_ petscsubcommsetoptionsprefix
#endif
PETSC_EXTERN void petscsubcommsetoptionsprefix_(PetscSubcomm *a, char b[], PetscErrorCode *ierr, PETSC_FORTRAN_CHARLEN_T l_b)
{
  char* c_b;
  FIXCHAR(b, l_b, c_b);
  *ierr = PetscSubcommSetOptionsPrefix(*a, c_b);
  if (*ierr) return;
  FREECHAR(b, c_b);
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommview_ PETSCSUBCOMMVIEW
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommview_ petscsubcommview
#endif
PETSC_EXTERN void petscsubcommview_(PetscSubcomm *a, PetscViewer *b, PetscErrorCode *ierr)
{
  PetscViewer v_b = PetscPatchDefaultViewers(b);
  *ierr = PetscSubcommView(*a, v_b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommsetnumber_ PETSCSUBCOMMSETNUMBER
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommsetnumber_ petscsubcommsetnumber
#endif
PETSC_EXTERN void petscsubcommsetnumber_(PetscSubcomm *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = PetscSubcommSetNumber(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommsettype_ PETSCSUBCOMMSETTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommsettype_ petscsubcommsettype
#endif
PETSC_EXTERN void petscsubcommsettype_(PetscSubcomm *a, PetscSubcommType *b, PetscErrorCode *ierr)
{
  *ierr = PetscSubcommSetType(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommsettypegeneral_ PETSCSUBCOMMSETTYPEGENERAL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommsettypegeneral_ petscsubcommsettypegeneral
#endif
PETSC_EXTERN void petscsubcommsettypegeneral_(PetscSubcomm *a, PetscMPIInt *b, PetscMPIInt *c, PetscErrorCode *ierr)
{
  *ierr = PetscSubcommSetTypeGeneral(*a, *b, *c);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommdestroy_ PETSCSUBCOMMDESTROY
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommdestroy_ petscsubcommdestroy
#endif
PETSC_EXTERN void petscsubcommdestroy_(PetscSubcomm *a, PetscErrorCode *ierr)
{
  PETSC_FORTRAN_OBJECT_F_DESTROYED_TO_C_NULL(a);
  PetscBool null_a = !*(void**) a ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(a);
  *ierr = PetscSubcommDestroy(a);
  if (*ierr) return;
  if (! null_a && !*(void**) a) *(void **) a = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsys.h>
#include <petscsys.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define petscsubcommcreate_ PETSCSUBCOMMCREATE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define petscsubcommcreate_ petscsubcommcreate
#endif
PETSC_EXTERN void petscsubcommcreate_(MPI_Fint *a, PetscSubcomm *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  PETSC_FORTRAN_OBJECT_CREATE(b);
  CHKFORTRANNULLOBJECT(b);
  *ierr = PetscSubcommCreate(MPI_Comm_f2c(*(a)), b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
