#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taodefaultcomputegradient_ TAODEFAULTCOMPUTEGRADIENT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taodefaultcomputegradient_ taodefaultcomputegradient
#endif
PETSC_EXTERN void taodefaultcomputegradient_(Tao *a, Vec *b, Vec *c, void *d, PetscErrorCode *ierr)
{
  *ierr = TaoDefaultComputeGradient(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taodefaultcomputehessian_ TAODEFAULTCOMPUTEHESSIAN
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taodefaultcomputehessian_ taodefaultcomputehessian
#endif
PETSC_EXTERN void taodefaultcomputehessian_(Tao *a, Vec *b, Mat *c, Mat *d, void *e, PetscErrorCode *ierr)
{
  *ierr = TaoDefaultComputeHessian(*a, *b, *c, *d, e);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taodefaultcomputehessiancolor_ TAODEFAULTCOMPUTEHESSIANCOLOR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taodefaultcomputehessiancolor_ taodefaultcomputehessiancolor
#endif
PETSC_EXTERN void taodefaultcomputehessiancolor_(Tao *a, Vec *b, Mat *c, Mat *d, void *e, PetscErrorCode *ierr)
{
  *ierr = TaoDefaultComputeHessianColor(*a, *b, *c, *d, e);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taodefaultcomputehessianmffd_ TAODEFAULTCOMPUTEHESSIANMFFD
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taodefaultcomputehessianmffd_ taodefaultcomputehessianmffd
#endif
PETSC_EXTERN void taodefaultcomputehessianmffd_(Tao *a, Vec *b, Mat *c, Mat *d, void *e, PetscErrorCode *ierr)
{
  *ierr = TaoDefaultComputeHessianMFFD(*a, *b, *c, *d, e);
  if (*ierr) return;
}
